EXPORTS.xmlstr2json = function(str)
{
	var stack = [];
	stack.unshift({});
	var driver = new SAXDriver();
	driver.setDocumentHandler(
	{
		processingInstruction: function(name, data)
		{
			if (stack.length == 1 && name == "xml")
			{
				data = data.split(" ");
				for (var i = 0; i < data.length; i++)
				{
					var pair = data[i].split("=");
					stack[0][pair[0]] = pair[1].replace(/'/g, '');
				}
			}
		},
		
		startElement: function(name, attrs)
		{
			var elem = {};
			var len = attrs.getLength();
			for (var i = 0; i < len; i++)
			{
				elem[attrs.getName(i)] = attrs.getValue(i);
			}
			var curr = stack[0][name];
			if (Object.isArray(curr))
			{
				curr.push(elem);
			}
			else if (curr)
			{
				stack[0][name] = [ curr, elem ];
			}
			else
			{
				stack[0][name] = elem;
			}
			stack.unshift(elem);
		},
		
		endElement: function()
		{
			stack.shift();
		},
		
		characters: function(data, start, length)
		{
			stack[0].$t = data.substr(start, length);
		},
	});
	driver.parse(str);
	return stack[0];
};

EXPORTS.xmldom2json = function(xmldom)
{
	function node2json(jnode, xnode)
	{
		var name = xnode.nodeName.replace(':', '$');
		switch (xnode.nodeType)
		{
			case 1: // Element
				var jchild = {};
				if (Object.isArray(jnode[name]))
				{
					jnode[name].push(jchild);
				}
				else if (jnode[name])
				{
					jnode[name] = [ jnode[name], jchild ];
				}
				else
				{
					jnode[name] = jchild;
				}
				var attributes = xnode.attributes;
				var len = attributes.length;
				for (var i = 0; i < len; i++)
				{
					var item = attributes.item(i);
					jchild[item.name] = item.value;
				}
				for (var xchild = xnode.firstChild; xchild; xchild = xchild.nextSibling)
				{
					node2json(jchild, xchild);
				}
				break;
				
			case 2: // Attribute
				jnode[name] = xnode.nodeValue;
				break;
				
			case 3: // Text
				var val = xnode.nodeValue;
				if (val.search(/\S/) != -1)
				{
					jnode.$t = val;
				}
				break;
				
			case 9: // Document
				node2json(jnode, xnode.firstChild);
				break;
				
			case 8: // Comment
			default:
				break;
		}
		return jnode;
	};
	return node2json({}, xmldom);
};

EXPORTS.xml2json = function(xml)
{
	if (typeof xml == "string")
	{
		return EXPORTS.xmlstr2json(xml);
	}
	else
	{
		return EXPORTS.xmldom2json(xml);
	}
}
